package soccerTeamExample_delegatedControllerVersion;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class SoccerAppController implements ActionListener {

	private TeamMemberModel theModel;
	private TeamMemberView theView;
	private boolean isActive = false;

	public SoccerAppController(TeamMemberView view, TeamMemberModel model) {
		theModel = model;
		theView = view;

		/**
		 * pp. 101-102. The widgets will generate events that are produced when
		 * the user types new text into the text boxed. We want the controller
		 * to be aware of such events so that it can update the model
		 * accordingly.
		 * 
		 */
		theView.getFirstNameComponent().addActionListener(this);
		theView.getLastNameComponent().addActionListener(this);
		theView.getAddressComponent().addActionListener(this);
		theView.getPhoneNumberComponent().addActionListener(this);

	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (isActive)
			return;
		isActive = true;
		theModel.setFirstName(theView.getFirstNameComponent().getText());
		theModel.setLastName(theView.getLastNameComponent().getText());
		theModel.setAddress(theView.getAddressComponent().getText());
		theModel.setPhoneNumber(theView.getPhoneNumberComponent().getText());
		isActive = false;
	}

}
